#!bin/sh

if [ $# -ne 1 -a $# -ne 2 ]; then
	echo "usage: $0 <start|stop|setkey> [debug level]" >&2
	exit 1
fi

#
# Global variables
#

KLDLOAD=kldload
KLDUNLOAD=kldunload
SYSCTL=sysctl
IFCONFIG=ifconfig

MODULE_NAME=rt2870.ko
SYSCTL_NODE_DEBUG=dev.rt2870.0.debug
DEBUG_LEVEL=${2:-0}
IFACE=rt28700

CHANNEL=4
SSID=home_network
KEYINDEX=1
KEY=0x73657267656a5f265f616c6578

#
# drv_start
#
drv_start()
{
	$KLDLOAD ./$MODULE_NAME

	$SYSCTL $SYSCTL_NODE_DEBUG=$DEBUG_LEVEL

	$IFCONFIG $IFACE channel $CHANNEL ssid $SSID up
	#$IFCONFIG $IFACE channel $CHANNEL ssid $SSID wepmode on up
	#$IFCONFIG $IFACE channel $CHANNEL ssid $SSID wme wepmode on up
}

#
# drv_stop
#
drv_stop()
{
	$IFCONFIG $IFACE down

	$KLDUNLOAD $MODULE_NAME
}

#
# drv_setkey
#
drv_setkey()
{
	$IFCONFIG $IFACE wepkey $KEYINDEX:$KEY weptxkey $KEYINDEX
}

case $1 in
	start)
		drv_stop >/dev/null 2>&1
		drv_start
	;;

	stop)
		drv_stop >/dev/null 2>&1
	;;

	setkey)
		drv_setkey
	;;

	*)
		echo "usage: $0 <start|stop|setkey>" >&2
		exit 1
	;;
esac
