
#ifndef _RT2870_EEPROM_H_
#define _RT2870_EEPROM_H_

#define RT2870_EEPROM_VERSION					0x0002
#define RT2870_EEPROM_ADDRESS					0x0004
#define RT2870_EEPROM_ANTENNA					0x0034
#define RT2870_EEPROM_CONFIG					0x0036
#define RT2870_EEPROM_COUNTRY					0x0038
#define RT2870_EEPROM_RF_FREQ_OFF				0x003a
#define RT2870_EEPROM_LED1_OFF					0x003c
#define RT2870_EEPROM_LED2_OFF					0x003e
#define RT2870_EEPROM_LED3_OFF					0x0040
#define RT2870_EEPROM_LNA_GAIN					0x0044
#define RT2870_EEPROM_RSSI1_OFF_2GHZ			0x0046
#define RT2870_EEPROM_RSSI2_OFF_2GHZ			0x0048
#define RT2870_EEPROM_RSSI1_OFF_5GHZ			0x004a
#define RT2870_EEPROM_RSSI2_OFF_5GHZ			0x004c
#define RT2870_EEPROM_TXPOW_COMP_DELTA			0x0050
#define RT2870_EEPROM_TXPOW_2GHZ_BASE1			0x0052
#define RT2870_EEPROM_TXPOW_2GHZ_BASE2			0x0060
#define RT2870_EEPROM_TSSI_2GHZ_BOUND1			0x006e
#define RT2870_EEPROM_TSSI_2GHZ_BOUND2			0x0070
#define RT2870_EEPROM_TSSI_2GHZ_BOUND3			0x0072
#define RT2870_EEPROM_TSSI_2GHZ_BOUND4			0x0074
#define RT2870_EEPROM_TSSI_2GHZ_BOUND5			0x0076
#define RT2870_EEPROM_TXPOW_5GHZ_BASE1			0x0078
#define RT2870_EEPROM_TXPOW_5GHZ_BASE2			0x00a6
#define RT2870_EEPROM_TSSI_5GHZ_BOUND1			0x00d4
#define RT2870_EEPROM_TSSI_5GHZ_BOUND2			0x00d6
#define RT2870_EEPROM_TSSI_5GHZ_BOUND3			0x00d8
#define RT2870_EEPROM_TSSI_5GHZ_BOUND4			0x00da
#define RT2870_EEPROM_TSSI_5GHZ_BOUND5			0x00dc
#define RT2870_EEPROM_TXPOW_COMP_BASE			0x00de
#define RT2870_EEPROM_BBP_BASE					0x00f0

#define RT2870_EEPROM_RF_2820					1 /* 2.4GHz 2T3R */
#define RT2870_EEPROM_RF_2850					2 /* 2.4/5GHz 2T3R */
#define RT2870_EEPROM_RF_2720					3 /* 2.4GHz 1T2R */
#define RT2870_EEPROM_RF_2750					4 /* 2.4G/5GHz 1T2R */
#define RT2870_EEPROM_RF_3020					5 /* 2.4GHz 1T1R */
#define RT2870_EEPROM_RF_2020					6 /* 2.4GHz B/G */

#define RT2870_EEPROM_LED_POLARITY				(1 << 7)
#define RT2870_EEPROM_LED_MODE_MASK				0x7f

#define RT2870_EEPROM_LED_CNTL_DEFAULT			0x01
#define RT2870_EEPROM_LED1_OFF_DEFAULT			0x5555
#define RT2870_EEPROM_LED2_OFF_DEFAULT			0x2221
#define RT2870_EEPROM_LED3_OFF_DEFAULT			0x5627

#define RT2870_EEPROM_RSSI_OFF_MIN				-10
#define RT2870_EEPROM_RSSI_OFF_MAX				10

#define RT2870_EEPROM_TXPOW_2GHZ_MIN			0
#define RT2870_EEPROM_TXPOW_2GHZ_MAX			31
#define RT2870_EEPROM_TXPOW_2GHZ_DEFAULT		5
#define RT2870_EEPROM_TXPOW_5GHZ_MIN			-7
#define RT2870_EEPROM_TXPOW_5GHZ_MAX			15
#define RT2870_EEPROM_TXPOW_5GHZ_DEFAULT		5

#endif /* #ifndef _RT2870_EEPROM_H_ */
