
#ifndef _RT2870_IO_H_
#define _RT2870_IO_H_

#include "rt2870_softc.h"

#define RT2870_IO_MCU_CMD_SLEEP					0x30
#define RT2870_IO_MCU_CMD_WAKEUP				0x31
#define RT2870_IO_MCU_CMD_LEDS					0x50
#define RT2870_IO_MCU_CMD_LED_BRIGHTNESS		0x51
#define RT2870_IO_MCU_CMD_LED1					0x52
#define RT2870_IO_MCU_CMD_LED2					0x53
#define RT2870_IO_MCU_CMD_LED3					0x54
#define RT2870_IO_MCU_CMD_BOOT					0x72

uint32_t rt2870_io_mac_read(struct rt2870_softc *sc, uint16_t reg);

void rt2870_io_mac_read_multi(struct rt2870_softc *sc,
	uint16_t reg, void *buf, size_t len);

void rt2870_io_mac_write(struct rt2870_softc *sc,
	uint16_t reg, uint32_t val);

void rt2870_io_mac_write_multi(struct rt2870_softc *sc,
	uint16_t reg, void *buf, size_t len);

void rt2870_io_mac_set_region_4(struct rt2870_softc *sc,
	uint16_t reg, uint32_t val, size_t len);

uint16_t rt2870_io_eeprom_read(struct rt2870_softc *sc, uint16_t addr);

void rt2870_io_eeprom_read_multi(struct rt2870_softc *sc,
	uint16_t addr, void *buf, size_t len);

uint8_t rt2870_io_bbp_read(struct rt2870_softc *sc, uint8_t reg);

void rt2870_io_bbp_write(struct rt2870_softc *sc, uint8_t reg, uint8_t val);

void rt2870_io_rf_write(struct rt2870_softc *sc, uint8_t reg, uint32_t val);

void rt2870_io_mcu_cmd(struct rt2870_softc *sc, uint8_t cmd, uint16_t arg);

int rt2870_io_mcu_load_ucode(struct rt2870_softc *sc,
	const uint8_t *ucode, size_t len);

int rt2870_io_mcu_reset(struct rt2870_softc *sc);

#endif /* #ifndef _RT2870_IO_H_ */
