
#include "rt2870_led.h"
#include "rt2870_eeprom.h"
#include "rt2870_io.h"

/*
 * rt2870_led_brightness
 */
void rt2870_led_brightness(struct rt2870_softc *sc, uint8_t brightness)
{
	uint8_t polarity;
	uint16_t tmp;

	polarity = (sc->led_cntl & RT2870_EEPROM_LED_POLARITY) ? 1 : 0;

	tmp = (polarity << 8) | brightness;

	rt2870_io_mcu_cmd(sc, RT2870_IO_MCU_CMD_LED_BRIGHTNESS, tmp);
}

/*
 * rt2870_led_cmd
 */
void rt2870_led_cmd(struct rt2870_softc *sc, uint8_t cmd)
{
	uint16_t tmp;

	tmp = (cmd << 8) | (sc->led_cntl & RT2870_EEPROM_LED_MODE_MASK);

	rt2870_io_mcu_cmd(sc, RT2870_IO_MCU_CMD_LEDS, tmp);
}
