
#ifndef _RT2870_RXWI_H_
#define _RT2870_RXWI_H_

#define RT2870_RXWI_KEYIDX_SHIFT			0
#define RT2870_RXWI_KEYIDX_MASK				0x3

#define RT2870_RXWI_BSSIDX_SHIFT			2
#define RT2870_RXWI_BSSIDX_MASK				0x7

#define RT2870_RXWI_UDF_SHIFT				5
#define RT2870_RXWI_UDF_MASK				0x7

#define RT2870_RXWI_SIZE_SHIFT				0
#define RT2870_RXWI_SIZE_MASK				0xfff

#define RT2870_RXWI_TID_SHIFT				12
#define RT2870_RXWI_TID_MASK				0xf

#define RT2870_RXWI_FRAG_SHIFT				0
#define RT2870_RXWI_FRAG_MASK				0xf

#define RT2870_RXWI_SEQ_SHIFT				4
#define RT2870_RXWI_SEQ_MASK				0xfff

#define RT2870_RXWI_MCS_SHIFT				0
#define RT2870_RXWI_MCS_MASK				0x7f
#define RT2870_RXWI_MCS_SHOTPRE				(1 << 3)

#define RT2870_RXWI_BW_SHIFT				7
#define RT2870_RXWI_BW_MASK					0x1

#define RT2870_RXWI_SHORTGI_SHIFT			0
#define RT2870_RXWI_SHORTGI_MASK			0x1

#define RT2870_RXWI_STBC_SHIFT				1
#define RT2870_RXWI_STBC_MASK				0x3

#define RT2870_RXWI_PHYMODE_SHIFT			6
#define RT2870_RXWI_PHYMODE_MASK			0x3
#define RT2870_RXWI_PHYMODE_CCK				0
#define RT2870_RXWI_PHYMODE_OFDM			1

struct rt2870_rxwi
{
	uint8_t wcid;
	uint8_t udf_bssidx_keyidx;
	uint16_t tid_size;
	uint16_t seq_frag;
	uint8_t bw_mcs;
	uint8_t phymode_stbc_shortgi;
	uint8_t rssi[3];
	uint8_t reserved1;
	uint8_t snr[2];
	uint16_t reserved2;
} __packed;

#endif /* #ifndef _RT2870_RXWI_H_ */
